#|

This file is a part of NUMCL project.
Copyright (c) 2019 IBM Corporation
SPDX-License-Identifier: LGPL-3.0-or-later

NUMCL is free software: you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any
later version.

NUMCL is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
NUMCL.  If not, see <http://www.gnu.org/licenses/>.

|#

(in-package :numcl.impl)


;; cholesky(a) 	Cholesky decomposition.
;; det(a) 	Compute the determinant of an array.
;; eig(a) 	Compute the eigenvalues and right eigenvectors of a square array.
;; eigh(a[, UPLO]) 	Return the eigenvalues and eigenvectors of a Hermitian or symmetric matrix.
;; eigvals(a) 	Compute the eigenvalues of a general matrix.
;; eigvalsh(a[, UPLO]) 	Compute the eigenvalues of a Hermitian or real symmetric matrix.
;; inv(a) 	Compute the (multiplicative) inverse of a matrix.
;; lstsq(a, b[, rcond]) 	Return the least-squares solution to a linear matrix equation.
;; norm(x[, ord, axis, keepdims]) 	Matrix or vector norm.
;; pinv(a[, rcond]) 	Compute the (Moore-Penrose) pseudo-inverse of a matrix.
;; solve(a, b) 	Solve a linear matrix equation, or system of linear scalar equations.
;; svd(a[, full_matrices, compute_uv]) 	Singular Value Decomposition.

